

#include "irc.h"
#include "edit.h"
#include "list.h"
#include "hook.h"
#include "ircaux.h"
#include "output.h"
#include "screen.h"
#include "server.h"
#include "struct.h"
#include "window.h"
#include "whois.h"
#include "vars.h"
#include "pluto.h"



static int defban = 1;

/*
 * Lamer Kick!   Kicks All UnOpped People from Current Channel        
 */

void LameKick(char *command, char *args, char *subargs)
{
	char *channel = NULL;
	ChannelList *chan;
	NickList *tmp;
	char	*buffer = NULL;
	if (get_channel_by_refnum(0))
	{
		malloc_strcpy(&channel, get_channel_by_refnum(0));
		chan = lookup_channel(channel, curr_scr_win->server, 0);
		if (*args)
			malloc_sprintf(&buffer, "%s <%s-LK>", version, args);
		else
			malloc_sprintf(&buffer, "<%s-LK>", version);
		for (tmp = chan->nicks; tmp; tmp = tmp->next)
		{
			if (!tmp->chanop && !tmp->voice && ((tmp->userlist && !tmp->userlist->prot) || !tmp->userlist))
			{
				send_to_server("%s %s %s :%s", command, channel, tmp->nick, buffer);
			}
		}
		new_free(&buffer);
		say("Sent the Server all the Lamer Kicks, Sit back and Watch!");
	}
	else
		say("No Current Channel for this Window!");
}

void shitlist_erase(ShitList **clientlist)
{
	ShitList	*Client, *tmp;
	for (Client = *clientlist; Client;)
	{
		new_free(&Client->filter);
		new_free(&Client->reason);
		tmp = Client->next;
		new_free((char **)&Client);
		Client = tmp;
	}
	*clientlist = NULL;
}

void userhost_unban(WhoisStuff *stuff, char *nick, char *args)
{
char *tmp;
ChannelList *chan;
BanList *bans;
char *host = NULL;
int count = 0;
	if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
	{
		bitchsay("No match for the unban of %s on %s", nick, args);
		return;
	}
	tmp = stuff->user;
	if (*tmp == '~')
		tmp++;
	if (*tmp == '#')
		tmp++;
	malloc_sprintf(&host, "%s!%s@%s",stuff->nick, tmp, stuff->host); 
	if (!(chan = lookup_channel(args, from_server, CHAN_NOUNLINK)))
	{
		bitchsay("Error looking up channel %s in userhost-unban", args);
		return;
	}
	for (bans = chan->bans; bans; bans = bans->next)
	{
		if (wild_match(bans->ban, host) || wild_match(host, bans->ban))
		{
			send_to_server("MODE %s -b %s", args, bans->ban);
			count++;
		}			
	}	
	if (!count)
		bitchsay("No Match for Unban of %s on %s", stuff->nick, args);
	new_free(&host);
}

char *screw(char *user)
{
char *p;
	for (p = user; p && *p;)
	{
		switch(*p)
		{
			case '.':
			case '*':
			case '@':
			case '!':
				p+=1;
				break;
			default:
				*p = '?';
				p+=2;
		}
	}
	return user;
}

void userhost_ban(WhoisStuff *stuff, char *nick, char *args)
{
	char *temp;
	char *str= NULL;
	char *tmpstr = NULL;
	char *channel;
	char *ob = "-o+b";
	char *b = "+b";
	int fuck = 0;
	channel = next_arg(args, &args);
	temp = next_arg(args, &args);
	fuck = my_stricmp("FUCK", args) ? 0 : 1;
	if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
	{
		bitchsay("No match for the %s of %s on %s", fuck ? "Fuck":"Ban", nick, channel);
		return;
	}
	if (!(my_stricmp(stuff->nick, get_server_nickname(from_server))))
	{
		bitchsay("Try to kick yourself again!!");
		return;
	}
	temp = stuff->user;
	if (*temp == '~')
		temp++;
	if (*temp == '#')
		temp++;
	while (strlen(temp) > 9)
		temp++;		
	switch (defban) 
	{
		case 2: /* Better 	*/
			send_to_server("MODE %s %s *!*%s@%s", channel, stuff->channel ? ob : b,
			       temp, cluster(stuff->host));
			break;
		case 3: /* Host 	*/
			send_to_server("MODE %s %s *!*@%s", channel, stuff->channel ? ob : b,
			       cluster(stuff->host));
			break;
		case 4: /* Screw 	*/
			tmpstr = (char *)new_malloc(80);
			sprintf(tmpstr, "*!*%s@%s", temp, cluster(stuff->host));
			send_to_server("MODE %s %s %s", channel, 
				stuff->channel ? ob : b, screw(tmpstr));
			new_free(&tmpstr);
			break;
		case 1:	/* Normal 	*/
		default:
			send_to_server("MODE %s %s *!*%s@%s", channel, stuff->channel ? ob : b,
				temp, stuff->host);
			break;
	}
	if (fuck)
	{
		malloc_sprintf(&str, "%s!*%s@%s %s 3 Auto-Shit", stuff->nick, temp, stuff->host, channel);
		add_shit(NULL, str, NULL);
		new_free(&str);
	}
}

#if 0
void userhost_siteban(WhoisStuff *stuff, char *nick, char *args)
{
	char *temp;

	if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
	{
		say("No match for the siteban of %s on %s",
		    nick, args);
		return;
	}
	temp = stuff->user;
	if (temp && (*temp == '~'))
		temp++;
	if (temp && (*temp == '#'))
		temp++;
	send_to_server("MODE %s -o+b *!*@%s", args,
		       cluster(stuff->host));
}
#endif

void multkick(char *command, char *args, char *subargs)
{
	char *to, *temp, *reason;

	reason = (char *) NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		temp = to;
		if (args && *args)
			*(temp + strlen(temp)) = ' ';
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!temp || !*temp)
	{
		say("Who am I supposed to multikick?");
		return;
	}
	reason = strchr(temp, ':');
	if (reason)
		reason++;
	if (!reason || !*reason)
		reason = get_reason(NULL);
	while (temp && *temp && (*temp != ':'))
		send_to_server("KICK %s %s :\002%s\002", to,
			       new_next_arg(temp, &temp), reason);
}

void massdeop(char *command, char *args, char *subargs)
{
	ChannelList *chan;
	NickList *nicks;
	char *to, *spec, *rest;
	char modebuf[BIG_BUFFER_SIZE + 1];
	int maxmodes, count, i, all;
	char	buffer[BIG_BUFFER_SIZE + 1];

	all = 0;		/*
				 * deop those who are already deopped too? 
				 */
	maxmodes = get_int_var(NUM_OPMODES_VAR);
	rest = NULL;
	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}

	if (!spec && !(spec = new_next_arg(args, &args)))
		spec = "*!*@*";
	if (*spec == '-')
	{
		rest = spec;
		spec = "*!*@*";
	}
	else
		rest = args;
	if (rest && !my_stricmp(rest, "-all"))
		all = 1;

	if (!(chan = lookup_channel(to, from_server, 0)))
	{
		say("Error looking up channel %s", to);
		return;
	}

	nicks = chan->nicks;
	count = 0;
	while (nicks)
	{
		i = 0;
		*modebuf = '\0';
		while (nicks && (i < maxmodes))
		{
			strcpy(buffer, "");
			strcat(buffer, nicks->nick);
			if (!nicks->host)
			{
				say("ERROR: No userhost for %s", nicks->nick);
				continue;
			}
			strcat(buffer, "!");
			strcat(buffer, nicks->host);
			if ((all || nicks->chanop) &&
			    my_stricmp(nicks->nick, get_server_nickname(from_server)) &&
			    wild_match(spec, buffer))
			{
				count++;
				i++;
				strcat(modebuf, " ");
				strcat(modebuf, nicks->nick);
			}
			nicks = nicks->next;
		}
		if (i)
			send_to_server("MODE %s -oooo %s", to, modebuf);
	}
	if (!count)
		say("No matches for massdeop of %s on %s", spec, to);
}

void doop(char *command, char *args, char *subargs)
{
	char *to, *temp;
	int count, max;
	char buffer[BIG_BUFFER_SIZE + 1];
	
	count = 0;
	temp = NULL;
	max = get_int_var(NUM_OPMODES_VAR);
	strcpy(buffer, "");
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		temp = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}

	if (!temp)
		temp = new_next_arg(args, &args);

	while (temp && *temp)
	{
		count++;
		strncat(buffer, temp, BIG_BUFFER_SIZE);
		if (count == max)
		{
			send_to_server("MODE %s +oooo %s", to, buffer);
			count = 0;
			*buffer = '\0';
		}
		else
			strncat(buffer, " ", BIG_BUFFER_SIZE);
		temp = new_next_arg(args, &args);
	}
	if (count)
		send_to_server("MODE %s +oooo %s", to, buffer);
}

void dodeop(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *temp;
	int count, max;
	char	buffer[BIG_BUFFER_SIZE + 1];
	
	count = 0;
	temp = NULL;
	max = get_int_var(NUM_OPMODES_VAR);
	strcpy(buffer, "");
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		temp = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!temp)
		temp = new_next_arg(args, &args);

	while (temp && *temp)
	{
		count++;
		strncat(buffer, temp, BIG_BUFFER_SIZE);
		if (count == max)
		{
			send_to_server("MODE %s -oooo %s", to, buffer);
			count = 0;
			*buffer = '\0';
		}
		else
			strncat(buffer, " ", BIG_BUFFER_SIZE);
		temp = new_next_arg(args, &args);
	}
	if (count)
		send_to_server("MODE %s -oooo %s", to, buffer);
}

void massop(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	ChannelList *chan;
	NickList *nicks;
	char *to, *spec, *rest;
	char modebuf[BIG_BUFFER_SIZE + 1];
	char	buffer[BIG_BUFFER_SIZE + 1];
	int maxmodes, count, i, all;

	all = 0;		/*
				 * op those who are already opped too? 
				 */
	maxmodes = get_int_var(NUM_OPMODES_VAR);
	rest = NULL;
	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}

	if (!spec && !(spec = new_next_arg(args, &args)))
		spec = "*!*@*";
	if (*spec == '-')
	{
		rest = spec;
		spec = "*!*@*";
	}
	else
		rest = args;
	if (rest && !my_stricmp(rest, "-all"))
		all = 1;

	if (!(chan = lookup_channel(to, from_server, 0)))
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	count = 0;
	while (nicks)
	{
		i = 0;
		*modebuf = '\0';
		while (nicks && (i < maxmodes))
		{
			strcpy(buffer, "");
			strcat(buffer, nicks->nick);
			strcat(buffer, "!");
			strcat(buffer, nicks->host);
			if ((all || !nicks->chanop) &&
			    my_stricmp(nicks->nick, get_server_nickname(from_server)) &&
			    wild_match(spec, buffer))
			{
				count++;
				i++;
				strncat(modebuf, " ", BIG_BUFFER_SIZE);
				strncat(modebuf, nicks->nick, BIG_BUFFER_SIZE);
			}
			nicks = nicks->next;
		}
		if (i)
			send_to_server("MODE %s +oooo %s", to, modebuf);
	}
	if (!count)
		say("No matches for massop of %s on %s", spec, to);
}

void masskick(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	ChannelList *chan;
	NickList *nicks;
	ShitList *masskick_list = NULL, *new;
	char *to, *spec, *rest, *buffer = NULL, *q;
	int all;

	all = 0;		/*
				 * kick those who are opped too? 
				 */
	rest = NULL;
	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		say("No pattern given for the masskick");
		return;
	}
	if (args && !strncmp(args, "-all", 4))
	{
		all = 1;
		(void) new_next_arg(args, &args);
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}

	nicks = chan->nicks;

	while (nicks)
	{
		q = nicks->host;
		if (q && *q == '~') q++;
		if (q && *q == '#') q++;
		malloc_sprintf(&buffer, "%s!*%s", nicks->nick, q);		
		if ((all || !nicks->chanop || get_int_var(KICK_OPS_VAR)) &&
		    my_stricmp(nicks->nick, get_server_nickname(from_server)) &&
		    wild_match(spec, buffer))
		{
			new = (ShitList *)new_malloc(sizeof(ShitList));
			malloc_sprintf(&new->filter, "%s", nicks->nick);
			malloc_strcpy(&new->reason, rest? rest : get_reason(nicks->nick));
			add_to_list((List **)&masskick_list, (List *)new);
		}
		nicks = nicks->next;
		new_free(&buffer);
	}
	
	

	if (masskick_list)
	{
		bitchsay("Performing (%s) MaSS KicKs on %s", all? "opz/non-opz":"non-opz", to);
		for (new = masskick_list; new; new = new->next)
			send_to_server("KICK %s %s :\002%s\002", to, new->filter, new->reason);
		shitlist_erase(&masskick_list);
	}
	else
		bitchsay("No matches for masskick of %s on %s", spec, to);
}

void mknu(command, args, subargs)
char *command, *args, *subargs;
{
	ChannelList *chan;
	NickList *nicks;
	char *to, *rest;
	int count;
	char	buffer[BIG_BUFFER_SIZE + 1];
	
	to = NULL;
	if (!args || !*args)
		to = "*";
	else if (*args == '#' || *args == '&' || !strncmp(args, "* ", 2) ||
		 !strcmp(args, "*"))
		to = next_arg(args, &args);
	else
		to = "*";
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	count = 0;
	while (nicks)
	{
		*buffer = '\0';
		strcat(buffer, nicks->nick);
		strcat(buffer, "!");
		strcat(buffer, nicks->host);
		if (!nicks->chanop &&
		my_stricmp(nicks->nick, get_server_nickname(from_server)))
		{
			count++;
			send_to_server("KICK %s %s :(non-users) \002%s\002", to, nicks->nick, rest ? rest : get_reason(nicks->nick));
		}
		nicks = nicks->next;
	}
	if (!count)
		say("No matches for masskick of non-users on %s", to);
}

void masskickban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	ChannelList *chan;
	NickList *nicks;
	char *to, *spec, *rest;
	int count, all;
	char	buffer[BIG_BUFFER_SIZE + 1];
	
	all = 0;		/*
				 * kick those who are opped too? 
				 */
	rest = NULL;
	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		say("No pattern given for the masskick");
		return;
	}
	if (args && !strncmp(args, "-all", 4))
	{
		all = 1;
		(void) new_next_arg(args, &args);
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;

	if (!(chan = lookup_channel(to, from_server, 0)))
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	count = 0;
	if (!strchr(spec, '!'))
	{
		char tempbuf[BIG_BUFFER_SIZE+1];

		strcpy(tempbuf, "*!");
		if (!strchr(spec, '@'))
			strcat(tempbuf, "*@");
		strcat(tempbuf, spec);
		send_to_server("MODE %s +b %s", to, tempbuf);
	}
	else
		send_to_server("MODE %s +b %s", to, spec);

	while (nicks)
	{
		*buffer = '\0';
		strcat(buffer, nicks->nick);
		strcat(buffer, "!");
		strcat(buffer, nicks->host);
		if ((all || !nicks->chanop || get_int_var(KICK_OPS_VAR)) &&
		    my_stricmp(nicks->nick, get_server_nickname(from_server)) &&
		    wild_match(spec, buffer))
		{
			count++;
			send_to_server("KICK %s %s :(%s) \002%s\002", to, nicks->nick, spec, rest ? rest : get_reason(nicks->nick));
		}
		nicks = nicks->next;
	}
	if (!count)
		say("No matches for masskickban of %s on %s", spec, to);
}

void massban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	ChannelList *chan;
	NickList *nicks;
	ShitList *massban_list = NULL, *tmp;
	char *to, *spec, *rest;
	char *buffer = NULL;

	int maxmodes, all;

	all = 0;		/*
				 * op those who are already opped too? 
				 */
	maxmodes = get_int_var(NUM_BANMODES_VAR);
	rest = NULL;
	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = new_next_arg(args, &args)))
		spec = "*!*@*";
	if (*spec == '-')
	{
		rest = spec;
		spec = "*!*@*";
	}
	else
		rest = args;

	if (rest && !my_stricmp(rest, "-all"))
		all = 1;

	chan = lookup_channel(to, from_server, 0);

	if (chan == NULL)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;

	while (nicks)
	{
		new_free(&buffer);
		malloc_sprintf(&buffer, "%s!%s", nicks->nick, nicks->host);

		if ((all || !nicks->chanop || get_int_var(KICK_OPS_VAR)) &&
		    my_stricmp(nicks->nick, get_server_nickname(from_server)) &&
		    wild_match(spec, buffer))
		{
			char *temp = NULL;
			char *p, *q;
			ShitList *new;
			malloc_strcpy(&temp, nicks->host);

			q = nicks->host;
			if (q && (*q == '~'))
				q++;
			if (q && (*q == '#'))
				q++;
			p = strchr(nicks->host, '@');
			*p++ = '\0';
		
			new = (ShitList *)new_malloc(sizeof(ShitList));
			malloc_sprintf(&new->filter, "*!*%s@%s ", q, cluster(p));
			add_to_list((List **)&massban_list, (List *)new);
			new_free(&temp);
		}
		nicks = nicks->next;
	}
	new_free(&buffer);
	if (massban_list)
	{
		char modestr[100];
		int i = 0;
		
		bitchsay("Performing MAss Kicks on %s", to);
		for (tmp = massban_list; tmp; tmp = tmp->next)
		{
			malloc_strcat(&buffer, tmp->filter);
			modestr[i] = 'b';
			i++;
			if (i > maxmodes)
			{
				modestr[i] = '\0';
				send_to_server("MODE %s +%s %s", to, modestr, buffer);
				i = 0;
				new_free(&buffer);
			}
		}
		modestr[i] = '\0';
		if (buffer && *buffer)
		{
			send_to_server("MODE %s +%s %s", to, modestr, buffer);
			new_free(&buffer);
		}
		shitlist_erase(&massban_list);
	} else
		say("No matches for massban of %s on %s", spec, to);
}

void unban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *host;
	ChannelList *chan;
	BanList *bans;
	int count = 0;
			
	to = spec = host = NULL;

	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}

	chan = lookup_channel(to, from_server, 0);
	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		spec = "*";
		host = "*@*";
	}
	if (spec && *spec == '#')
	{
		count = atoi(spec);	
	}
	if (!strchr(spec, '*'))
	{
		add_to_userhost_queue(spec, userhost_unban, "%s", to);
		return;
	}

	if (count)
	{
		int tmp = 1;
		for (bans = chan->bans; bans; bans = bans->next)
		{
			if (tmp == count)
			{
				if (bans->sent_unban == 0)
				{
					send_to_server("MODE %s -b %s", to, bans->ban);
					tmp = 0;
					break;
				}
			} else
				tmp++;
		}
		if (tmp != 0)
			count = 0;
	} 
	else 
	{
		count = 0;	
		for (bans = chan->bans; bans; bans = bans->next)
		{
			if (wild_match(bans->ban, spec) || wild_match(spec, bans->ban))
			{
				if (bans->sent_unban == 0)
				{
					send_to_server("MODE %s -b %s", to, bans->ban);
					count++;
				}
			}
		}
	}
	if (!count)
		bitchsay("No ban matching %s found", spec);

}

void dokick(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *reason;

	spec = NULL;
	if (!(to = new_next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && strcmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!strcmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		say("No nickname specified.");
		return;
	}
	if (args && *args)
		reason = args;
	else
		reason = get_reason(spec);

	send_to_server("KICK %s %s :%s", to, spec, reason);
}

void kickban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *rest;
	ChannelList *chan;
	NickList *nicks;

	spec = NULL;
	if (!(to = next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && my_stricmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!my_stricmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = next_arg(args, &args)))
	{
		say("No nickname specified");
		return;
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	while (nicks)
	{
		if (!my_stricmp(spec, nicks->nick))
		{
			char *temp, *user;
			char *host;
			char *tmpstr = NULL;
			char *t = NULL;

			malloc_strcpy(&t, nicks->host);
			temp = t;
			if (temp && (*temp == '~'))
				temp++;
			if (temp && (*temp == '#'))
				temp++;
			user = temp;
			host = strchr(temp, '@');
			*host++ = '\0';
	/* user = username  host = to hostname */
	switch (defban) 
	{
		case 2: /* Better 	*/
			send_to_server("MODE %s -o+b %s *!*%s@%s", to, nicks->nick, user, cluster(host));
			break;
		case 3: /* Host 	*/
			send_to_server("MODE %s -o+b %s *!*@%s", to, nicks->nick, cluster(host));
			break;
		case 4: /* Screw 	*/
			tmpstr = (char *)new_malloc(180);
			sprintf(tmpstr, "%s!*%s@%s", nicks->nick, user, cluster(host));
			send_to_server("MODE %s -o+b %s %s", to, nicks->nick, screw(tmpstr));
			new_free(&tmpstr);
			break;
		case 1:	/* Normal 	*/
		default:
			send_to_server("MODE %s -o+b %s %s!*%s@%s", to, nicks->nick,
			       nicks->nick, user, host);
			break;
	}
#if 0
			send_to_server("MODE %s -o+b %s *!*%s", to,
				       nicks->nick, temp);
#endif
			send_to_server("KICK %s %s :%s", to, nicks->nick,
				       rest ? rest : get_reason(nicks->nick));
			temp = NULL;
			if (command && !strcmp(command, "FUCK"))
			{
				malloc_sprintf(&temp, "%s!*%s@%s %s 3 Auto-Shit", nicks->nick, user, host, to);
				add_shit(NULL, temp, NULL);
				new_free(&temp);
			}
			new_free(&t);
			return;
		}
		
		nicks = nicks->next;
	}
	add_to_userhost_queue(spec, userhost_ban, "%s %s %s", to, spec, command ? ((strcmp(command, "FUCK") == 0) ? "FUCK": ""):"");
}

#if 0
void sitekickban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *rest;
	ChannelList *chan;
	NickList *nicks;

	spec = NULL;
	if (!(to = next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && my_stricmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!my_stricmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = next_arg(args, &args)))
	{
		say("No nickname specified");
		return;
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	while (nicks)
	{
		if (!my_stricmp(spec, nicks->nick))
		{
			char *p;

			p = strchr(nicks->host, '@');
			p++;
			send_to_server("MODE %s -o+b %s *!*@%s", to,
				       nicks->nick, cluster(p));
			send_to_server("KICK %s %s :%s", to, nicks->nick,
				       rest ? rest : get_reason(nicks->nick));
			return;
		}
		nicks = nicks->next;
	}
	add_to_userhost_queue(spec, userhost_siteban, "%s", to);
}
#endif

void ban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *rest;
	ChannelList *chan;
	NickList *nicks;

	spec = NULL;
	if (!(to = next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && my_stricmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!my_stricmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}

	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		bitchsay("/ban [nick][nick!*@*]");
		return;
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	while (nicks)
	{
		if (!my_stricmp(spec, nicks->nick))
		{
			char *temp;

			temp = nicks->host;
			if (temp && (*temp == '~'))
				temp++;
			if (temp && (*temp == '#'))
				temp++;
			send_to_server("MODE %s -o+b %s *!*%s", to,
				       nicks->nick, temp);
			return;
		}
		nicks = nicks->next;
	}
	add_to_userhost_queue(spec, userhost_ban, "%s %s", to, spec);
}

#if 0
void siteban(command, args, subargs)
char *command;
char *args;
char *subargs;
{
	char *to, *spec, *rest;
	ChannelList *chan;
	NickList *nicks;
	char *host = NULL, *p;

	spec = NULL;
	if (!(to = next_arg(args, &args)))
		to = "*";
	if (!is_channel(to) && my_stricmp(to, "*"))
	{
		spec = to;
		to = "*";
	}
	if (!my_stricmp(to, "*"))
		if ((to = get_channel_by_refnum(0)) == NULL)
		{
			not_on_a_channel();
			return;
		}
	if (!are_you_opped(to))
	{
		you_not_opped(to);
		return;
	}
	if (!spec && !(spec = new_next_arg(args, &args)))
	{
		say("No nickname specified");
		return;
	}
	rest = args;
	if (rest && !*rest)
		rest = NULL;
	chan = lookup_channel(to, from_server, 0);
	if (NULL == chan)
	{
		say("Error looking up channel %s", to);
		return;
	}
	nicks = chan->nicks;
	while (nicks)
	{
		if (!my_stricmp(spec, nicks->nick))
		{
			malloc_strcpy(&host, nicks->host);
			p = strchr(host, '@');
			*p++ = '\0';
			send_to_server("MODE %s -o+b %s *!*@%s", to,
				       nicks->nick, cluster(p));
			new_free(&host);
			return;
		}
		nicks = nicks->next;
	}
	add_to_userhost_queue(spec, userhost_siteban, "%s", to);
}
#endif

void banstat(char *command, char *args, char *subargs)
{
char *channel = NULL, *tmp = NULL, *check = NULL;
ChannelList *chan;
BanList *tmpc;
int count = 1;
	if (args && !*args)
		malloc_strcpy(&channel, get_channel_by_refnum(0));
	else
	{
		tmp = next_arg(args, &args);
		if (*tmp == '#' && is_channel(tmp))
			malloc_strcpy(&channel, tmp);
		else
			malloc_strcpy(&check, tmp);
		if (args && *args && channel)
		{
			tmp = next_arg(args, &args);			
			malloc_strcpy(&check, tmp);
		}		
	}
	if (channel && (chan = lookup_channel(channel, from_server, 0)))
	{
		if (!chan->bans)
		{
			bitchsay("No bans on %s", channel);
			return;
		}
		for (tmpc = chan->bans; tmpc; tmpc = tmpc->next, count++)
		{
			if (check && (!wild_match(check, tmpc->ban) || !wild_match(tmpc->ban, check)))
				continue;
			if (tmpc->sent_unban)
				continue;
			if (do_hook(BANS_LIST, "%d %s %s %s %lu", count, channel, tmpc->ban, tmpc->setby?tmpc->setby:get_server_name(from_server), (unsigned long)tmpc->time))
				put_it("BL: #%d %s [%s] SetBy: %20s %lu", count, channel, tmpc->ban, tmpc->setby?tmpc->setby:get_server_name(from_server), (unsigned long)tmpc->time);
		}
		new_free(&check);
		new_free(&channel);
	} else
		bitchsay("No channel or error");

}

/*
 * Stolen from cdcc 1.5 from Sheik/FliEr. With permission.
 */
 
int matchmcommand(char *origline,int count)
{
    int  startnum=0;
    int  endnum=0;
    char *tmpstr;
    char tmpbuf[BIG_BUFFER_SIZE];

    strcpy(tmpbuf,origline);
    tmpstr=tmpbuf;
    if (*tmpstr=='*') return(1);
    while (tmpstr && *tmpstr) {
        startnum=0;
        endnum=0;
        if (tmpstr && *tmpstr && *tmpstr=='-') {
            while (tmpstr && *tmpstr && !isdigit(*tmpstr)) tmpstr++;
            endnum=atoi(tmpstr);
            startnum=1;
            while (tmpstr && *tmpstr && isdigit(*tmpstr)) tmpstr++;
        }
        else {
            while (tmpstr && *tmpstr && !isdigit(*tmpstr)) tmpstr++;
            startnum=atoi(tmpstr);
            while (tmpstr && *tmpstr && isdigit(*tmpstr)) tmpstr++;
            if (tmpstr && *tmpstr && *tmpstr=='-') {
                while (tmpstr && *tmpstr && !isdigit(*tmpstr)) tmpstr++;
                endnum=atoi(tmpstr);
                if (!endnum) endnum=1000;
                while (tmpstr && *tmpstr && isdigit(*tmpstr)) tmpstr++;
            }
        }
        if (count==startnum || (count>=startnum && count<=endnum)) return(1);
    }
    if (count==startnum || (count>=startnum && count<=endnum)) return(1);
    return(0);
}

void remove_bans _((char *stuff, char *line))
{
ChannelList *chan;
int count = 1;
BanList *tmpc;
	if (stuff && (chan = lookup_channel(stuff, from_server, 0)))
	{
	
		if (!chan->bans)
		{
			bitchsay("No bans on %s", stuff);
			return;
		}
		for (tmpc = chan->bans; tmpc; tmpc = tmpc->next, count++)
			if ((matchmcommand(line, count)))
				send_to_server("MODE %s -b %s", stuff, tmpc->ban);
	}	
}

void tban(char *command, char *args, char *subargs)
{
char *channel;
ChannelList *chan;
int found = 0;
int count = 1;
BanList *tmpc;
	channel = get_channel_by_refnum(0);
	if (channel && (chan = lookup_channel(channel, from_server, 0)))
	{
	
		for (tmpc = chan->bans; tmpc; tmpc = tmpc->next)
			if (!tmpc->sent_unban)
				found++;
		if (!found)
		{
			bitchsay("No bans on %s", channel);
			return;
		}
		for (tmpc = chan->bans; tmpc; tmpc = tmpc->next, count++)
			if (!tmpc->sent_unban && do_hook(BANS_LIST, "%d %s %s %s %lu", count, channel, tmpc->ban, tmpc->setby?tmpc->setby:get_server_name(from_server), (unsigned long)tmpc->time))
				put_it("BL: #%d %s [%s] SetBy: %20s %lu", count, channel, tmpc->ban, tmpc->setby?tmpc->setby:get_server_name(from_server), (unsigned long)tmpc->time);

		add_wait_prompt("Which ban to delete (-2, 2-5, ...) ? ", remove_bans, channel, WAIT_PROMPT_LINE);
	} else
		bitchsay("No channel or error");
}

void bantype (char *command, char *args, char *subargs)
{
	if (args && *args)
	{
		switch (toupper(*args))
		{
			case 'N':
				defban = 1;
				break;
			case 'B':
				defban = 2;
				break;
			case 'H':
				defban = 3;
				break;
			case 'S':
				defban = 4;
				break;
			default:
				bitchsay("Usage: /bantype [N]ormal, [B]etter, [H]ost, [S]crew");
				break;
		}
	}		
	bitchsay("Ban Type set to - \002%s\002", (defban == 1) ? "Normal" : (defban == 2) ? "Better" : (defban == 3) ? "Host" : "Screw");
}
